/**************************************************************/
/*                                                            */
/* User-Defined Functions for temperature-dependent viscosity */
/* FLUENT 5.0                                                 */
/*                                                            */
/* Author: Liz Marshall                                       */
/*   Date: February 1998                                      */
/*                                                            */
/**************************************************************/




#include "udf.h"


DEFINE_PROPERTY(user_vis, cell, thread)


{

  
real temp, mu;


  temp = C_T(cell, thread);


  {


/*If the temperature is high, use a small, constant viscosity */

 
 if (temp > 288.)
      mu = 5.5e-3;


/* Otherwise, use a profile to get higher viscosity values */


  else if (temp >= 286. )
  
    mu = 143.2135 - 0.49725 * temp;


  else
      
mu = 1.0;

}
  
return mu;

}

